var beaconScanner;

function BeaconListener(in_mac, in_tx_power) {
   this.MAC = in_mac;
   IR.SetVariable("Global.BeaconMAC", in_mac);
   this.TXPower = in_tx_power;
   IR.SetVariable("Global.BeaconTXPower", in_tx_power);
   
   this.Name;
   this.CurrentRSSI;
   this.AverageRSSI;
   this.Distance;
   
   var RSSI_History = [];
   
   function Init() {
      if(!beaconScanner) {
         beaconScanner = IR.CreateDevice(IR.DEVICE_BLE_SCANNER);     
      }
      beaconScanner.Connect();
   }

	function HistoryPush(in_rssi) {
		if(in_rssi < 0) {
			if(RSSI_History.length == 20) {
				RSSI_History.shift();
				RSSI_History.push(in_rssi);
			} else {
				RSSI_History.push(in_rssi);
			}
		}
	}
	
	function AverageUpdate() {
		var summ = 0;
		for(var i = 0; i < RSSI_History.length; i++) {
			summ += RSSI_History[i];
		}
		var ave = summ/RSSI_History.length;
      
      this.AverageRSSI = ave;
      IR.SetVariable("Global.BeaconRSSI_ave", ave);
      
      var t_dist = getDistance.call(this, ave);
   	if (t_dist != -1) {
   		this.Distance = t_dist;
         IR.SetVariable("Global.BeaconDistance", t_dist);
   	}         
	}
	
	function getDistance(in_rssi) { 
		if (in_rssi > 0) {
			return -1;
		}
		var ratio = in_rssi * 1.0 / this.TXPower;
		if (ratio < 1.0) {
			return parseFloat(Math.pow(ratio, 10).toFixed(1))
		} else {
			return parseFloat((0.89976 * Math.pow(ratio, 7.7095) + 0.111).toFixed(1))
		}
	}
   
   function BLEreceive(in_mac, in_name, in_rssi, in_advertisementData) {
      
      if(in_rssi < 0) {
         if(in_mac == this.MAC) {
            IR.SetVariable("Global.BeaconName", in_name);
            this.CurrentRSSI = in_rssi;
            IR.SetVariable("Global.BeaconRSSI_cur", in_rssi);
            HistoryPush(in_rssi);
            AverageUpdate.call(this);
         }
      }
   }
   
   IR.AddListener(IR.EVENT_DEVICE_BLE_FOUND, 0, BLEreceive, this);
   
   Init();
   
   
   var Events = [];
   
   this.AddEvent = function(in_distance, in_callback_enter, in_callback_exit) {
      if(in_distance) {
         var t_event = {
            Distance : in_distance,
            Status : 0
         }            
         if(in_callback_enter) {
            t_event.EnterCallback = in_callback_enter;
         }
         if(in_callback_exit) {
            t_event.ExitCallback = in_callback_exit;
         }
         Events.push(t_event);
      }
   }
   
   function EventManager(name, value) {
      for(var i = 0; i < Events.length; i++) {
         if(Events[i].Status) {
            if(value > Events[i].Distance) {
               Events[i].Status = 0;
               if(Events[i].ExitCallback) {
                  Events[i].ExitCallback();
               }
            }   
         } else {
            if(value < Events[i].Distance) {
               Events[i].Status = 1;
               if(Events[i].EnterCallback) {
                  Events[i].EnterCallback();
               }
            }               
         }
      }   
   }
   
   
   IR.SetGlobalListener(IR.EVENT_GLOBAL_TAG_CHANGE, EventManager, this);
   IR.SubscribeTagChange("Global.BeaconDistance"); 
}
